diff --exclude='*~' -ruN emacs-23.3/configure emacs-23.3.patched/configure
--- emacs-23.3/configure	2011-03-07 06:29:43.000000000 +0100
+++ emacs-23.3.patched/configure	2011-11-30 22:41:26.000000000 +0100
@@ -2466,7 +2466,7 @@
 etcdir='${datadir}/emacs/${version}/etc'
 archlibdir='${libexecdir}/emacs/${version}/${configuration}'
 docdir='${datadir}/emacs/${version}/etc'
-gamedir='${localstatedir}/games/emacs'
+gamedir='${localstatedir}/games/emacs23'
 
 gameuser=games
 
diff --exclude='*~' -ruN emacs-23.3/configure.in emacs-23.3.patched/configure.in
--- emacs-23.3/configure.in	2011-03-01 03:28:57.000000000 +0100
+++ emacs-23.3.patched/configure.in	2011-11-30 22:41:50.000000000 +0100
@@ -476,12 +476,6 @@
     opsys=darwin
     # Define CPP as follows to make autoconf work correctly.
     CPP="${CC-cc} -E -no-cpp-precomp"
-    # Use fink packages if available.
-    if test -d /sw/include && test -d /sw/lib; then
-      GCC_TEST_OPTIONS="-I/sw/include -L/sw/lib"
-      CPP="${CPP} ${GCC_TEST_OPTIONS}"
-      NON_GCC_TEST_OPTIONS=${GCC_TEST_OPTIONS}
-    fi
   ;;
 
   ## HP 9000 series 700 and 800, running HP/UX
diff -Nurd -x'*~' emacs-23.3.orig/lisp/startup.el emacs-23.3/lisp/startup.el
--- emacs-23.3.orig/lisp/startup.el	2011-01-08 12:45:14.000000000 -0500
+++ emacs-23.3/lisp/startup.el	2011-10-10 12:25:38.000000000 -0400
@@ -375,6 +375,10 @@
 
 (defvar normal-top-level-add-subdirs-inode-list nil)
 
+(defconst fink-emacs-flavor 'emacs23
+  "A symbol representing the particular fink flavor of emacs running.
+Something like 'emacs20, 'xemacs20, etc.")
+
 (defvar no-blinking-cursor nil)
 
 (defvar default-frame-background-mode)
@@ -955,9 +959,19 @@
     ;; be loaded from site-run-file and wants to test if -q was given
     ;; should check init-file-user instead, since that is already set.
     ;; See cus-edit.el for an example.
-    (if site-run-file
-	(load site-run-file t t))
-
+    ;; (if site-run-file                                                       
+    ;;     (load site-run-file t t))                                           
+                                                                               
+    ;; Fink version of site-start.                                           
+    (if site-run-file                                                          
+ 	(progn                                                                 
+ 	  ;; Load all the fink package snippets.                             
+ 	  ;; It's in here because we want -q to kill it too.                   
+ 	  (if (load "fink-startup" t t nil)                                  
+ 	      (fink-startup fink-emacs-flavor))                            
+ 	  ;; Now the normal site file...                                       
+ 	  (load site-run-file t t nil)))
+    
     ;; Sites should not disable this.  Only individuals should disable
     ;; the startup screen.
     (setq inhibit-startup-screen nil)
diff --exclude='*~' -ruN emacs-23.3/src/nsfont.m emacs-23.3.patched/src/nsfont.m
--- emacs-23.3/src/nsfont.m	2011-01-08 18:45:14.000000000 +0100
+++ emacs-23.3.patched/src/nsfont.m	2011-11-30 22:55:22.000000000 +0100
@@ -1278,7 +1278,7 @@
       }
 
     CGContextRestoreGState (gcontext);
-    return;
+    return 0;
   }
 #endif  /* NS_IMPL_COCOA */
 
diff --exclude='*~' -ruN emacs-23.3/src/nsimage.m emacs-23.3.patched/src/nsimage.m
--- emacs-23.3/src/nsimage.m	2011-01-08 18:45:14.000000000 +0100
+++ emacs-23.3.patched/src/nsimage.m	2011-11-30 22:55:22.000000000 +0100
@@ -325,7 +325,7 @@
 
 /* Set color for a bitmap image (see initFromSkipXBM).  Note that the alpha
    is used as a mask, so we just memset the entire array. */
-- setXBMColor: (NSColor *)color
+- (void) setXBMColor: (NSColor *)color
 {
   NSSize s = [self size];
   int len = (int) s.width * s.height;
diff --exclude='*~' -ruN emacs-23.3/src/nsterm.m emacs-23.3.patched/src/nsterm.m
--- emacs-23.3/src/nsterm.m	2011-02-09 00:46:22.000000000 +0100
+++ emacs-23.3.patched/src/nsterm.m	2011-12-14 15:28:42.000000000 +0100
@@ -5106,7 +5106,8 @@
 
   win = [[EmacsWindow alloc]
             initWithContentRect: r
-                      styleMask: (NSResizableWindowMask |
+                      styleMask: (NSTitledWindowMask |
+                                  NSResizableWindowMask |
                                   NSMiniaturizableWindowMask |
                                   NSClosableWindowMask)
                         backing: NSBackingStoreBuffered
@@ -5431,7 +5432,7 @@
   NSTRACE (performDragOperation);
 
   if (!emacs_event)
-    return;
+    return NO;
 
   position = [self convertPoint: [sender draggingLocation] fromView: nil];
   x = lrint (position.x);  y = lrint (position.y);